﻿namespace UltraGridFlatExcelExport
{
    using System;
    using System.Data;
    using System.Diagnostics;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinGrid;
    using Infragistics.Win.UltraWinGrid.ExcelExport;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
            this.Load += Form1_Load;
            this.ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
            this.buttonExport.Click += ButtonExport_Click;
            this.ultraGridExcelExporter1.ExportStarted += UltraGridExcelExporter1_ExportStarted;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            var data = this.GetData();
            this.ultraGrid1.SetDataBinding(data, data.TableName);
        }

        private void UltraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];

            layout.Override.GroupByRowInitialExpansionState = GroupByRowInitialExpansionState.Expanded;
            band.SortedColumns.Add(band.Columns[0], false, true);
        }

        private void ButtonExport_Click(object sender, EventArgs e)
        {
            var fileName = "test.xlsx";
            this.ultraGridExcelExporter1.Export(this.ultraGrid1, fileName, Infragistics.Documents.Excel.WorkbookFormat.Excel2007);

            Process.Start(fileName);
        }

        private void UltraGridExcelExporter1_ExportStarted(object sender, ExportStartedEventArgs e)
        {
            e.Layout.Bands[0].SortedColumns.Clear();
        }

        private DataTable GetData(int rows = 30, int cols = 5)
        {
            DataTable dt = new DataTable();

            for(int col = 0; col < cols; col++)
            {
                dt.Columns.Add(string.Format("Column #{0}", col + 1), typeof(int));
            }

            var rnd = new Random();
            for(int row = 0; row < rows; row++)
            {
                DataRow addRow = dt.NewRow();
                foreach(DataColumn column in dt.Columns)
                {
                    addRow[column] = rnd.Next(10);
                }

                dt.Rows.Add(addRow);
            }

            return dt;
        }
    }
}
